﻿
@{
    @using APIFestival.Models
    ViewData["Title"] = "Programmation";
    List<Scene> listeScenes = (List<Scene>)ViewData["listeScenes"];
    List<Artiste> listeArtistes = (List<Artiste>)ViewData["listeArtistes"];
    List<JouerSur> listeJouerSurs = (List<JouerSur>)ViewData["listeJouerSurs"];
    //L'instruction ci dessous utilise le formalisme LINQ pour trier la liste (en fonction de l'heure de début de performance des artistes
    listeJouerSurs = (from jouerSur in listeJouerSurs orderby jouerSur.DateHeureDebutPerformance.TimeOfDay select jouerSur).ToList<JouerSur>();

    int nbrDeJours = (int)ViewData["nbrDeJoursDuFestival"];
    DateTime dateDeDebutFestival = (DateTime)ViewData["dateDeDebutFestival"];

    //Le code ci-dessous permet de gérer l'affichage du bon template de notification en fonction du type de celle-la
    String activerAttention = "";
    String activerSucces = "";
    String messageNotification = "";
    int zIndexAttention = 0;
    int zIndexSucces = 0;
    if (!string.IsNullOrEmpty((string)ViewData["messageAttention"]))
    {
        activerAttention = "montrerLeToastAttention";
        messageNotification = (string)ViewData["messageAttention"];
        zIndexAttention = 100;
    }
    if (!string.IsNullOrEmpty((string)ViewData["messageSucces"]))
    {
        activerSucces = "montrerLeToastSucces";
        messageNotification = (string)ViewData["messageSucces"];
        zIndexSucces = 100;
    }


}

<div class="row">
    @foreach (Scene scene in listeScenes)
    {
        <!--- TEMPLATE SCENE  ---->
        <div class="col-md-4">

            <div class="card bg-light">
                <div class="card-header bg-dark text-white">
                    @scene.NomScene
                    <div class="p-0">
                        <small style="line-height: 0px">
                            @scene.NombreDePlaces places <br>
                            @scene.Accessibilite
                        </small>
                    </div>
                </div>

                <div class="card-body p-2">
                    <!-- Affichage des onglets -->
                    <ul class="nav nav-tabs mb-3" id="myOnglets" role="tablist">
                        @for (int numJour = 1; numJour <= nbrDeJours; numJour++)
                        {
                            <li class="nav-item">
                                <!-- Le premier élement doit avoir une syntaxe différente des autres, car c'est lui qui est selectionné au démarrage de la page -->
                                @if (numJour == 1)
                                {
                                    <a class="nav-link active p-2" id="scene_@scene.Id-jour_@numJour-tab" data-toggle="tab" href="#scene_@scene.Id-jour_@numJour" role="tab" aria-controls="home" aria-selected="true"><small>Jour @numJour</small></a>
                                }
                                else
                                {
                                    <a class="nav-link p-2" id="scene_@scene.Id-jour_@numJour-tab" data-toggle="tab" href="#scene_@scene.Id-jour_@numJour" role="tab" aria-controls="home" aria-selected="false"><small>Jour @numJour</small></a>
                                }
                            </li>
                        }
                    </ul>
                    <!-- Affichage des onglets -->
                    <!--Contenu qui sera affiché par les onglets -->
                    <div class="tab-content" id="myOngletsContent">
                        @for (int numJour = 1; numJour <= nbrDeJours; numJour++)
                        {
                            //permet de rajouter l'attribut "active" au premier tab-pane
                            String activeOuNon = "";
                            if (numJour == 1)
                                activeOuNon = "active";
                            else
                                activeOuNon = "";
                            <div class="tab-pane fade show @activeOuNon" id="scene_@scene.Id-jour_@numJour" role="tabpanel" aria-labelledby="scene_@scene.Id-jour_@numJour-tab">
                                <!-- Permet d'afficher les artistes -->
                                @foreach (JouerSur jouerSur in listeJouerSurs)
                                {
                                    foreach (Artiste artiste in listeArtistes)
                                    {
                                        if (jouerSur.IdScn == scene.Id && jouerSur.IdArtiste == artiste.Id
                                            && jouerSur.DateHeureDebutPerformance.Day == (dateDeDebutFestival.Day + numJour - 1))
                                        {
                                            <!-- TEMPLATE ARTISTE -->
                                            <div class="card bg-light p-1 mb-3 card-artiste" id="card-artiste-@artiste.Id">
                                                <div class="media">
                                                    <img src="@artiste.UrlPhoto" alt="@artiste.Nom" class="img-thumbnail mr-3 imageArtiste" height="150" width="150">
                                                    <div class="media-body">
                                                        <!-- Dropright -->
                                                        <a class="fas fa-ellipsis-h fa-xs text-muted dropright float-right" data-toggle="dropdown" data-boundary="viewport"></a>
                                                        <div class="dropdown-menu p-0" style="min-width: 4em">
                                                            <small class="ml-2 mt-0"><a href="@artiste.Id" class="editLink" data-toggle="modal" data-target="#modalEdit">Edit</a></small><br>
                                                            <small class="ml-2"><a href="@artiste.Id" class="deleteLink" data-toggle="modal" data-target="#modalDelete">Delete</a></small>
                                                        </div>
                                                        <!-- Dropright -->
                                                        <h6 class="mb-0 nomArtiste">@artiste.Nom</h6>
                                                        <small>
                                                            <span class="paysArtiste">@artiste.PaysOrigine</span> | <span class="styleArtiste">@artiste.Style</span> <br>
                                                            <!-- Dans "H\\hmm", le \\ est la pour échapper le h et qu'il ne soit pas interprété comme un afficahge de l'heure bien comme la lettre h -->
                                                            <span class="heureDebutArtiste">@jouerSur.DateHeureDebutPerformance.ToString("H\\hmm")</span> - <span class="heureFinArtiste">@jouerSur.DateHeureFinPerformance.ToString("H\\hmm")</span> <br>
                                                            Extrait <a class="text-dark fas fa-play-circle extraitArtiste" href="@artiste.UrlExtraitMusical" target="_blank"></a>
                                                            <a data-toggle="collapse" href="#collapseDescription_@artiste.Id" class="float-right mt-2 mr-2 fas fa-angle-double-down"></a>
                                                        </small>
                                                    </div>
                                                </div>
                                                <small class="collapse p-2 descriptionArtiste" id="collapseDescription_@artiste.Id">@artiste.Descriptif</small>
                                            </div>
                                            <!-- TEMPLATE ARTISTE -->
                                        }
                                    }
                                }
                                <!-- Permet d'afficher les artistes -->
                                <!-- AJOUTER UN ARTISTE -->
                                <div class="card">
                                    <div class="card-header text-center p-1">
                                        <a data-toggle="collapse" href="#collapse_@scene.Id@numJour" class="">
                                            Ajouter un artiste
                                        </a>
                                    </div>

                                    <div class="collapse card-body bg-light" id="collapse_@scene.Id@numJour">
                                        <form method="post" action="GererProgrammation" enctype="multipart/form-data">

                                            <div class="form-group">
                                                <label for="nomArtiste"><small>Nom artiste</small></label>
                                                <input type="text" class="form-control form-control-sm" id="nomArtiste" placeholder="Nom" name="nomArtiste" required>
                                            </div>

                                            <div class="form-row">
                                                <div class="form-group col-5">
                                                    <label for="paysOrigine"><small>Pays d'origine</small></label>
                                                    <input type="text" class="form-control form-control-sm" id="paysOrigine" placeholder="Pays" name="paysOrigine">
                                                </div>
                                                <div class="form-group col-7">
                                                    <label for="genreMusical"><small>Genre Musical</small></label>
                                                    <input type="text" class="form-control form-control-sm" id="genreMusical" placeholder="Genre" name="genreMusical">
                                                </div>
                                            </div>

                                            <div class="form-row">
                                                <div class="form-group col-5">
                                                    <label for="horaires"><small>Heure entrée</small></label>
                                                    <input class="form-control form-control-sm" type="time" id="horaires" name="heureDebut" required>
                                                </div>
                                                <div class="form-group col-5">
                                                    <label for="horaires2"><small>Heure sortie</small></label>
                                                    <input class="form-control form-control-sm" type="time" id="horaires2" name="heureFin" required>
                                                </div>
                                            </div>

                                            <div class="form-group">
                                                <label for="extraitMusical"><small>Lien extrait musical</small></label>
                                                <input type="text" class="form-control form-control-sm" id="extraitMusical" placeholder="url de l'extrait" name="urlExtraitMusical" required>
                                            </div>

                                            <div clas="form-group">
                                                <label for="descriptionArtiste"><small>Description</small></label>
                                                <textarea type="text" class="form-control form-control-sm" id="descriptionArtiste" placeholder="Présentation de l'artiste" name="descriptionArtiste" required></textarea>
                                            </div>

                                            <div clas="form-group">
                                                <label for="photoArtiste"><small>Photo</small></label>
                                                <div class="custom-file">
                                                    <input type="file" class="custom-file-input" id="customFile" name="dataPhoto" required>
                                                    <label class="custom-file-label" for="customFile"><small>Choisissez un fichier....</small></label>
                                                </div>
                                            </div>

                                            <input type="hidden" name="idScene" value="@scene.Id" />
                                            <input type="hidden" name="numJour" value="@numJour" />


                                            <div class="row mt-3">
                                                <button type="submit" class="btn btn-dark mx-auto">Valider</button>
                                            </div>
                                        </form>
                                    </div>
                                </div>
                                <!-- AJOUTER UN ARTISTE -->

                            </div>
                        }
                    </div>
                    <!--Contenu qui sera affiché par les onglets -->

                </div>

            </div>

        </div>
        <!--- TEMPLATE SCENE ---->
    }
</div>
<!-- AJOUTER UNE SCENE -->

<div class="row">

    <div class="col-5 mx-auto mb-3 mt-4">
        <div class="card">

            <div class="card-header text-center p-1">
                <a data-toggle="collapse" href="#collapse_ajouter_scene" class="">
                    Ajouter une scène
                </a>
            </div>

            <div class="collapse card-body bg-light" id="collapse_ajouter_scene">
                <form method="post" action="GererProgrammation">

                    <div class="form-group">
                        <label for="nomScene"><small>Nom de la scène</small></label>
                        <input type="text" class="form-control form-control-sm" id="nomScene" placeholder="Nom de la Scène" name="nomScene" required>
                    </div>

                    <div class="form-group">
                        <label for="nbrPlaces"><small>Nombre de places</small></label>
                        <input type="number" class="form-control form-control-sm" id="nbrPlaces" placeholder="Capacité" name="nbrPlaces">
                    </div>

                    <div class="form-group">
                        <label for="description"><small>Description</small></label>
                        <input type="text" class="form-control form-control-sm" id="description" placeholder="Description" name="description">
                    </div>

                    <div clas="form-group">
                        <label for="accessibilite"><small>Accessibilité</small></label>
                        <textarea type="text" class="form-control form-control-sm" id="accessibilite" placeholder="Accessibilité" name="accessibilite" required></textarea>
                    </div>

                    <div class="row mt-3">
                        <button type="submit" class="btn btn-dark mx-auto">Valider</button>
                    </div>
                </form>
            </div>
        </div>

    </div>
</div>
<!-- AJOUTER UNE SCENE -->
<!-- Affichage des messages d'erreurs ou de succès -->
<!-- Message d'erreur -->
<div class="toast" style="position: absolute; top: 5em; right: 2em; z-index: @zIndexAttention;" id="@activerAttention" data-autohide="false">
    <div class="toast-header">
        <i class="fas fa-exclamation-triangle mr-2"></i>
        <strong class="mr-auto">Attention</strong>
        <small class="ml-4">Saisie Incorrecte</small>
        <button type="button" class="ml-2 mb-1 close" data-dismiss="toast" aria-label="Close">
            <span aria-hidden="true">&times;</span>
        </button>
    </div>
    <div class="toast-body">
        @messageNotification
    </div>
</div>
<!-- Message d'erreur -->
<!-- Message de succès -->
<div class="toast" style="position: absolute; top: 5em; right: 2em; z-index: @zIndexSucces;" id="@activerSucces" data-autohide="false">
    <div class="toast-header">
        <i class="far fa-check-circle mr-2"></i>
        <strong class="mr-auto">Succès</strong>
        <small class="ml-4">Enregistrement réussit</small>
        <button type="button" class="ml-2 mb-1 close" data-dismiss="toast" aria-label="Close">
            <span aria-hidden="true">&times;</span>
        </button>
    </div>
    <div class="toast-body">
        @messageNotification
    </div>
</div>
<!-- Message de succès -->
<!-- Affichage des messages d'erreurs ou de succès -->
<!--    Affichage des modals  -->
<!-- Modal Edit-->
<div class="modal fade" id="modalEdit" tabindex="-1" role="dialog">
    <div class="modal-dialog modal-dialog-centered" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLongTitle">Edition</h5>
                <button type="button" class="close" data-dismiss="modal">
                    <span>&times;</span>
                </button>
            </div>
            <div class="modal-body" id="contenuModalEdit">
                <form method="post" action="GererProgrammation" enctype="multipart/form-data">

                    <div class="form-group">
                        <label for="nomArtiste"><small>Nom artiste</small></label>
                        <input type="text" class="form-control form-control-sm" id="nomArtiste" placeholder="Nom" name="nomArtiste" required>
                    </div>

                    <div class="form-row">
                        <div class="form-group col-5">
                            <label for="paysOrigine"><small>Pays d'origine</small></label>
                            <input type="text" class="form-control form-control-sm" id="paysOrigine" placeholder="Pays" name="paysOrigine">
                        </div>
                        <div class="form-group col-7">
                            <label for="genreMusical"><small>Genre Musical</small></label>
                            <input type="text" class="form-control form-control-sm" id="genreMusical" placeholder="Genre" name="genreMusical">
                        </div>
                    </div>

                    <div class="form-row">
                        <div class="form-group col-5">
                            <label for="horaires"><small>Heure entrée</small></label>
                            <input class="form-control form-control-sm" type="time" id="horaires" name="heureDebut" required>
                        </div>
                        <div class="form-group col-5">
                            <label for="horaires2"><small>Heure sortie</small></label>
                            <input class="form-control form-control-sm" type="time" id="horaires2" name="heureFin" required>
                        </div>
                    </div>

                    <div class="form-group">
                        <label for="extraitMusical"><small>Lien extrait musical</small></label>
                        <input type="text" class="form-control form-control-sm" id="extraitMusical" placeholder="url de l'extrait" name="urlExtraitMusical" required>
                    </div>

                    <div clas="form-group">
                        <label for="descriptionArtiste"><small>Description</small></label>
                        <textarea type="text" class="form-control form-control-sm" id="descriptionArtiste" placeholder="Présentation de l'artiste" name="descriptionArtiste" required></textarea>
                    </div>

                    <div clas="form-group">
                        <label for="photoArtiste"><small>Photo</small></label>
                        <div class="custom-file">
                            <input type="file" class="custom-file-input" id="customFile" name="dataPhoto" required>
                            <label class="custom-file-label" for="customFile"><small>Changer la photo de l'artiste</small></label>
                        </div>
                    </div>
                    <input type="hidden" name="idArtisteAModifier" value="">
                </form>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-primary btn-sm float-left" data-dismiss="modal">Annuler</button>
                <button type="submit" class="btn btn-danger btn-sm boutonEnregistrer">Enregistrer</button>
            </div>
        </div>
    </div>
</div>
<!-- Modal Delete-->
<div class="modal fade" id="modalDelete" tabindex="-1" role="dialog">
    <div class="modal-dialog modal-dialog-centered" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLongTitle">Supprimer un artiste</h5>
                <button type="button" class="close" data-dismiss="modal">
                    <span>&times;</span>
                </button>
            </div>
            <div class="modal-body contenuModalDelete">
                ...
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-primary btn-sm float-left" data-dismiss="modal">Annuler</button>
                <form method="post" action="GererProgrammation">
                    <input type="hidden" name="idArtisteASupprimer" value="">
                    <button type="submit" class="btn btn-danger btn-sm boutonSupprimer">Supprimer</button>
                </form>
            </div>
        </div>
    </div>
</div>
<!-- Modal Delete-->
<!--    Affichage des modals  -->
<!-- Javascript nécessaire au bon fonctionnement de l'affichage de l'input file + les notifications + fenêtres de delete et d'edit -->
@section Scripts {
    <script src="https://cdn.jsdelivr.net/npm/bs-custom-file-input/dist/bs-custom-file-input.min.js"></script>
    <script type="text/javascript">
        //Nécessaire au bon fonctionnement de l'input file
        $(document).ready(function () {
            bsCustomFileInput.init()
        })
        //Permet d'afficher les notifications
        $('#montrerLeToastAttention').toast('show')
        $('#montrerLeToastSucces').toast('show')

        //Permet le remplissage des modals d'Edit et de Delete

        var listeCardArtistes = document.querySelectorAll('.card-artiste');
        for (let i = 0; i < listeCardArtistes.length; i++) {

            listeCardArtistes[i].querySelector('.editLink').addEventListener('click', onClickEdit);
            listeCardArtistes[i].querySelector('.deleteLink').addEventListener('click', onClickDelete);
        }

        function onClickEdit(e) {
            idArtisteClique = e.target.getAttribute('href');
            var cardArtiste = document.getElementById('card-artiste-' + idArtisteClique);
            var nomArtiste = cardArtiste.querySelector('.nomArtiste').textContent;
            var paysArtiste = cardArtiste.querySelector('.paysArtiste').textContent;
            var styleArtiste = cardArtiste.querySelector('.styleArtiste').textContent;
            var heureDebutArtiste = cardArtiste.querySelector('.heureDebutArtiste').textContent;
            heureDebutArtiste = transformerHeure(heureDebutArtiste);
            var heureFinArtiste = cardArtiste.querySelector('.heureFinArtiste').textContent;
            heureFinArtiste = transformerHeure(heureFinArtiste);
            var extraitArtiste = cardArtiste.querySelector('.extraitArtiste').getAttribute('href');
            var descriptionArtiste = cardArtiste.querySelector('.descriptionArtiste').textContent;
            var urlImageArtiste = cardArtiste.querySelector('.imageArtiste').getAttribute('src');


            var modalEdit = document.getElementById('modalEdit');
            modalEdit.querySelector('input[name="nomArtiste"]').setAttribute('value', nomArtiste);
            modalEdit.querySelector('input[name="paysOrigine"]').setAttribute('value', paysArtiste);
            modalEdit.querySelector('input[name="genreMusical"]').setAttribute('value', styleArtiste);
            modalEdit.querySelector('input[name="heureDebut"]').setAttribute('value', heureDebutArtiste);
            modalEdit.querySelector('input[name="heureFin"]').setAttribute('value', heureFinArtiste);
            modalEdit.querySelector('input[name="urlExtraitMusical"]').setAttribute('value', extraitArtiste);
            modalEdit.querySelector('textarea[name="descriptionArtiste"]').textContent = descriptionArtiste;
            modalEdit.querySelector('input[name="idArtisteAModifier"]').setAttribute('value', idArtisteClique);


            modalEdit.querySelector('.boutonEnregistrer').addEventListener('click', function () {
                modalEdit.querySelector('form').submit();
            });

        }


        var idArtisteClique;
        function onClickDelete(e) {
            idArtisteClique = e.target.getAttribute('href');
            var cardArtiste = document.getElementById('card-artiste-' + idArtisteClique);
            var nomArtisteASupprimer = cardArtiste.querySelector('.nomArtiste').textContent;

            var modalDelete = document.getElementById('modalDelete');
            modalDelete.querySelector('.contenuModalDelete').textContent = "Souhaitez vous vraiment supprimer " + nomArtisteASupprimer + "?";
            modalDelete.querySelector('input[name="idArtisteASupprimer"]').setAttribute('value', idArtisteClique);
        }

        function transformerHeure(heure) {
            if (heure.length <= 4) {
                heure = "0" + heure;
            }
            heure = heure.replace('h', ':');

            return heure;
        }

    </script>
}